package B4A.LongText;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "B4A.LongText", "B4A.LongText.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "B4A.LongText", "B4A.LongText.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "B4A.LongText.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public anywheresoftware.b4a.objects.LabelWrapper _lbltext = null;
public anywheresoftware.b4a.objects.ScrollViewWrapper _scvtext = null;
public anywheresoftware.b4a.objects.SpinnerWrapper _spntexts = null;
public anywheresoftware.b4a.objects.SpinnerWrapper _spnfont = null;
public anywheresoftware.b4a.objects.SpinnerWrapper _spnfontsize = null;
public anywheresoftware.b4a.keywords.constants.TypefaceWrapper _default = null;
public anywheresoftware.b4a.keywords.constants.TypefaceWrapper _times = null;
public anywheresoftware.b4a.keywords.constants.TypefaceWrapper _lucinda = null;
public anywheresoftware.b4a.objects.StringUtils _strutil = null;
public static String _txt = "";

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 25;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 28;BA.debugLine="Activity.LoadLayout(\"LongText\")";
mostCurrent._activity.LoadLayout("LongText",mostCurrent.activityBA);
 //BA.debugLineNum = 30;BA.debugLine="scvText.Panel.LoadLayout(\"LongText1\")";
mostCurrent._scvtext.getPanel().LoadLayout("LongText1",mostCurrent.activityBA);
 //BA.debugLineNum = 31;BA.debugLine="scvText.Height = 100%y - scvText.Top";
mostCurrent._scvtext.setHeight((int) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (100),mostCurrent.activityBA)-mostCurrent._scvtext.getTop()));
 //BA.debugLineNum = 33;BA.debugLine="Times = Typeface.LoadFromAssets(\"times.ttf\")";
mostCurrent._times.setObject((android.graphics.Typeface)(anywheresoftware.b4a.keywords.Common.Typeface.LoadFromAssets("times.ttf")));
 //BA.debugLineNum = 34;BA.debugLine="Lucinda = Typeface.LoadFromAssets(\"LHANDW.ttf\")";
mostCurrent._lucinda.setObject((android.graphics.Typeface)(anywheresoftware.b4a.keywords.Common.Typeface.LoadFromAssets("LHANDW.ttf")));
 //BA.debugLineNum = 36;BA.debugLine="FillTextFileSpinner";
_filltextfilespinner();
 //BA.debugLineNum = 37;BA.debugLine="FillFontSpinner";
_fillfontspinner();
 //BA.debugLineNum = 38;BA.debugLine="FillFontSizeSpinner";
_fillfontsizespinner();
 //BA.debugLineNum = 40;BA.debugLine="LoadText";
_loadtext();
 //BA.debugLineNum = 41;BA.debugLine="SetText";
_settext();
 //BA.debugLineNum = 42;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 48;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 50;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 44;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 46;BA.debugLine="End Sub";
return "";
}
public static String  _fillfontsizespinner() throws Exception{
 //BA.debugLineNum = 73;BA.debugLine="Sub FillFontSizeSpinner";
 //BA.debugLineNum = 74;BA.debugLine="spnFontSize.Add(14)";
mostCurrent._spnfontsize.Add(BA.NumberToString(14));
 //BA.debugLineNum = 75;BA.debugLine="spnFontSize.Add(16)";
mostCurrent._spnfontsize.Add(BA.NumberToString(16));
 //BA.debugLineNum = 76;BA.debugLine="spnFontSize.Add(20)";
mostCurrent._spnfontsize.Add(BA.NumberToString(20));
 //BA.debugLineNum = 77;BA.debugLine="End Sub";
return "";
}
public static String  _fillfontspinner() throws Exception{
 //BA.debugLineNum = 67;BA.debugLine="Sub FillFontSpinner";
 //BA.debugLineNum = 68;BA.debugLine="spnFont.Add(\"Default\")";
mostCurrent._spnfont.Add("Default");
 //BA.debugLineNum = 69;BA.debugLine="spnFont.Add(\"Times\")";
mostCurrent._spnfont.Add("Times");
 //BA.debugLineNum = 70;BA.debugLine="spnFont.Add(\"Lucida\")";
mostCurrent._spnfont.Add("Lucida");
 //BA.debugLineNum = 71;BA.debugLine="End Sub";
return "";
}
public static String  _filltextfilespinner() throws Exception{
int _i = 0;
String _tx = "";
anywheresoftware.b4a.objects.collections.List _filelist = null;
 //BA.debugLineNum = 52;BA.debugLine="Sub FillTextFileSpinner";
 //BA.debugLineNum = 53;BA.debugLine="Dim i As Int";
_i = 0;
 //BA.debugLineNum = 54;BA.debugLine="Dim tx As String";
_tx = "";
 //BA.debugLineNum = 55;BA.debugLine="Dim FileList As List";
_filelist = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 57;BA.debugLine="FileList=File.ListFiles(File.DirAssets)";
_filelist = anywheresoftware.b4a.keywords.Common.File.ListFiles(anywheresoftware.b4a.keywords.Common.File.getDirAssets());
 //BA.debugLineNum = 58;BA.debugLine="spnTexts.Clear";
mostCurrent._spntexts.Clear();
 //BA.debugLineNum = 59;BA.debugLine="For i = 0 To FileList.Size-1";
{
final int step32 = 1;
final int limit32 = (int) (_filelist.getSize()-1);
for (_i = (int) (0); (step32 > 0 && _i <= limit32) || (step32 < 0 && _i >= limit32); _i = ((int)(0 + _i + step32))) {
 //BA.debugLineNum = 60;BA.debugLine="tx = FileList.Get(i)";
_tx = BA.ObjectToString(_filelist.Get(_i));
 //BA.debugLineNum = 61;BA.debugLine="If tx.SubString(tx.Length-3) = \"txt\" Then";
if ((_tx.substring((int) (_tx.length()-3))).equals("txt")) { 
 //BA.debugLineNum = 62;BA.debugLine="spnTexts.Add(tx)";
mostCurrent._spntexts.Add(_tx);
 };
 }
};
 //BA.debugLineNum = 65;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 16;BA.debugLine="Dim lblText As Label";
mostCurrent._lbltext = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 17;BA.debugLine="Dim scvText As ScrollView";
mostCurrent._scvtext = new anywheresoftware.b4a.objects.ScrollViewWrapper();
 //BA.debugLineNum = 18;BA.debugLine="Dim spnTexts, spnFont, spnFontSize As Spinner";
mostCurrent._spntexts = new anywheresoftware.b4a.objects.SpinnerWrapper();
mostCurrent._spnfont = new anywheresoftware.b4a.objects.SpinnerWrapper();
mostCurrent._spnfontsize = new anywheresoftware.b4a.objects.SpinnerWrapper();
 //BA.debugLineNum = 19;BA.debugLine="Dim Default, Times, Lucinda As Typeface";
mostCurrent._default = new anywheresoftware.b4a.keywords.constants.TypefaceWrapper();
mostCurrent._times = new anywheresoftware.b4a.keywords.constants.TypefaceWrapper();
mostCurrent._lucinda = new anywheresoftware.b4a.keywords.constants.TypefaceWrapper();
 //BA.debugLineNum = 20;BA.debugLine="Dim StrUtil As StringUtils";
mostCurrent._strutil = new anywheresoftware.b4a.objects.StringUtils();
 //BA.debugLineNum = 22;BA.debugLine="Dim txt As String";
mostCurrent._txt = "";
 //BA.debugLineNum = 23;BA.debugLine="End Sub";
return "";
}
public static String  _loadtext() throws Exception{
 //BA.debugLineNum = 79;BA.debugLine="Sub LoadText";
 //BA.debugLineNum = 80;BA.debugLine="txt = File.GetText(File.DirAssets,spnTexts.SelectedItem)";
mostCurrent._txt = anywheresoftware.b4a.keywords.Common.File.GetText(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),mostCurrent._spntexts.getSelectedItem());
 //BA.debugLineNum = 81;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 11;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 13;BA.debugLine="End Sub";
return "";
}
public static String  _settext() throws Exception{
float _ht = 0f;
 //BA.debugLineNum = 104;BA.debugLine="Sub SetText";
 //BA.debugLineNum = 105;BA.debugLine="Dim ht As Float";
_ht = 0f;
 //BA.debugLineNum = 107;BA.debugLine="lblText.Text = txt";
mostCurrent._lbltext.setText((Object)(mostCurrent._txt));
 //BA.debugLineNum = 108;BA.debugLine="ht=StrUtil.MeasureMultilineTextHeight(lblText, txt)";
_ht = (float) (mostCurrent._strutil.MeasureMultilineTextHeight((android.widget.TextView)(mostCurrent._lbltext.getObject()),mostCurrent._txt));
 //BA.debugLineNum = 109;BA.debugLine="scvText.Panel.Height = ht";
mostCurrent._scvtext.getPanel().setHeight((int) (_ht));
 //BA.debugLineNum = 110;BA.debugLine="lblText.Height = ht";
mostCurrent._lbltext.setHeight((int) (_ht));
 //BA.debugLineNum = 112;BA.debugLine="scvText.ScrollPosition = 0";
mostCurrent._scvtext.setScrollPosition((int) (0));
 //BA.debugLineNum = 113;BA.debugLine="DoEvents	' needed to execute the line above";
anywheresoftware.b4a.keywords.Common.DoEvents();
 //BA.debugLineNum = 114;BA.debugLine="End Sub";
return "";
}
public static String  _spnfont_itemclick(int _position,Object _value) throws Exception{
 //BA.debugLineNum = 88;BA.debugLine="Sub spnFont_ItemClick (Position As Int, Value As Object)";
 //BA.debugLineNum = 89;BA.debugLine="If Position = 0 Then";
if (_position==0) { 
 //BA.debugLineNum = 90;BA.debugLine="lblText.Typeface = Typeface.Default";
mostCurrent._lbltext.setTypeface(anywheresoftware.b4a.keywords.Common.Typeface.DEFAULT);
 }else if(_position==1) { 
 //BA.debugLineNum = 92;BA.debugLine="lblText.Typeface = Times";
mostCurrent._lbltext.setTypeface((android.graphics.Typeface)(mostCurrent._times.getObject()));
 }else if(_position==2) { 
 //BA.debugLineNum = 94;BA.debugLine="lblText.Typeface = Lucinda";
mostCurrent._lbltext.setTypeface((android.graphics.Typeface)(mostCurrent._lucinda.getObject()));
 };
 //BA.debugLineNum = 96;BA.debugLine="SetText";
_settext();
 //BA.debugLineNum = 97;BA.debugLine="End Sub";
return "";
}
public static String  _spnfontsize_itemclick(int _position,Object _value) throws Exception{
 //BA.debugLineNum = 99;BA.debugLine="Sub spnFontSize_ItemClick (Position As Int, Value As Object)";
 //BA.debugLineNum = 100;BA.debugLine="lblText.TextSize = Value";
mostCurrent._lbltext.setTextSize((float)(BA.ObjectToNumber(_value)));
 //BA.debugLineNum = 101;BA.debugLine="SetText";
_settext();
 //BA.debugLineNum = 102;BA.debugLine="End Sub";
return "";
}
public static String  _spntexts_itemclick(int _position,Object _value) throws Exception{
 //BA.debugLineNum = 83;BA.debugLine="Sub spnTexts_ItemClick (Position As Int, Value As Object)";
 //BA.debugLineNum = 84;BA.debugLine="LoadText";
_loadtext();
 //BA.debugLineNum = 85;BA.debugLine="SetText";
_settext();
 //BA.debugLineNum = 86;BA.debugLine="End Sub";
return "";
}
}
